			function sendMethod(methodName, param) {
                window.location = "dbevent://"+ methodName + "&" + param;
            }

            function setMeaningContent(content,jsonHiddenDicts) {
                document.getElementById("db-div-content").innerHTML = content;
                updateLayoutWithHiddenDicts(jsonHiddenDicts);
                sendMethod("onMeaningLoaded","");
            }

            function showOptionContent(){
                //var arr= ["bb-more-dicts","bb-web-dicts","bb-combo-translate","bb-google"];
                var arr= ["bb-more-dicts","bb-web-dicts"];
                for (var i=0; i<arr.length; i++) {
                    ele = document.getElementById(arr[i]);
                    ele.style.display='block';
                }
            }

            function clearAllHighlights() {
                var arr = document.getElementsByTagName("span");
                //alert(arr);
                for (var i=0; i<arr.length; i++) {
                    if (arr[i].className != null && arr[i].className.length > 0) {
                        arr[i].className = arr[i].className.replace( "wordselected",'wordlink');
                    }
                }
            }

            function wlinkClicked(ele) {
                //alert(ele);
                clearAllHighlights();
				ele.className = "wordselected";
                //sendMethod("webview_onWLinkClicked", encodeURI(ele.textContent));

                    var arr = new Array();
                    if (ele.previousSibling && ele.previousSibling.textContent.indexOf("&") < 0)
                        arr.push(ele.previousSibling.textContent.trim());
                    else
                        arr.push("");

                    arr.push(ele.textContent.trim());

                    if (ele.nextSibling && ele.nextSibling.textContent.indexOf("&") < 0)
                        arr.push(ele.nextSibling.textContent.trim());
                    else
                        arr.push("");


                    var jsonStr = JSON.stringify(arr);
                   // alert(jsonStr);


                    sendMethod("webview_onWLinkClicked",encodeURI(jsonStr));
            }

			function tapOnWebView() {
                callNative("changeToImageMode")
            }

            function callNative(command) {
				var iframe = document.createElement("IFRAME");
				iframe.setAttribute("src", "dbevent://" + command);
				document.documentElement.appendChild(iframe);
				iframe.parentNode.removeChild(iframe);
				iframe = null;
			};

            function showDictionaryMeaningWithId(stringID) {
			    var ele = document.getElementById("meaning-" + stringID);
			    var eleButton = document.getElementById("button-" + stringID);

			    if (ele.style.display == 'none') {
			        ele.style.display = 'block';
			        eleButton.src = getURLForDrawableName("collapse");
			        sendMethod("onMeaningShown",stringID);
				}

			}


           function getURLForDrawableResource(fileName) {
                //return "file:///android_res/drawable/" + fileName;
           		return "file:///android_asset/image/" + fileName;
           }

           function onMeaningButtonTapped(stringID) {
           	//alert("aaaa" + stringID);
         	  	var ele = document.getElementById("meaning-" + stringID);
         	  	var eleButton = document.getElementById("button-" + stringID);

         	  	//alert(eleButton);


         	  	try {
         	  	if (ele.style.display == 'none') {
         	  		ele.style.display = 'block';
         	  		eleButton.src = getURLForDrawableResource("ic_action_collapse_blue.png");
         	  		sendMethod("onMeaningShown",stringID);
         	  	}
         	  	else {
         	  		ele.style.display = 'none';
         	  		eleButton.src = getURLForDrawableResource("ic_action_expand_blue.png");
         	  		sendMethod("onMeaningHidden",stringID);
         	  	}
         	  	}catch (err) {

         	  	}
           }

           function onDictSpeakerClicked(dictID) {
           		sendMethod("onDictSpeakerClicked",dictID);
           }

           function onSpeakerExClicked(inputEle) {

               var lang = inputEle.parentElement.getAttribute("lang");
               var jsonStr = JSON.stringify({'lang':lang});
               sendMethod("webview_onExSpeakerClicked", encodeURI(jsonStr));
           }

          function onSpeakerTranslatorClicked(inputEle) {
              var lang = inputEle.parentElement.getAttribute("lang");
              var sentences = inputEle.parentElement.textContent;
              var jsonStr = JSON.stringify({'lang':lang,'sentences':sentences});
              sendMethod("webview_onTranslatorSpeakerClicked", encodeURI(jsonStr));
          }


           function updateLayoutWithHiddenDicts(jsonDicts) {
           		var hDicts = eval('(' + jsonDicts + ')');

           		var eles = document.getElementsByTagName("input");

        		for (var i=0; i<eles.length; i++) {
            		var inputElement = eles[i];

            		if (inputElement.getAttribute("class") == "meaning-display") {

            			dictID = inputElement.parentElement.parentElement.id;

            			if (hDicts.indexOf(dictID) >= 0) {
	            			meaningElement = document.getElementById("meaning-" + dictID);
	            			meaningElement.style.display = 'none';
		         	  		inputElement.src = getURLForDrawableResource("ic_action_expand_blue.png");
	         	  		}
	         	  	}
                    else if (inputElement.getAttribute("class").indexOf("b-sspk-ex") >= 0) {
                        inputElement.src = getURLForDrawableResource("ic_action_speaker_blue_big.png");
                        inputElement.setAttribute("type","image");
                        inputElement.setAttribute("onclick","onSpeakerExClicked(this);");
                    }
                    else if (inputElement.getAttribute("class").indexOf("button-dict-speaker") >= 0) {
                        inputElement.src = getURLForDrawableResource("ic_action_speaker_blue_big.png");
                        inputElement.setAttribute("type","image");
                    }
        		}
           }

           function onSoundLoading(dictID){
                var meaning = document.getElementById('meaning-' + dictID);
                var eles = meaning.getElementsByTagName("input");

                for (var i=0; i<eles.length; i++) {
                    var inputElement = eles[i];
                    if (inputElement.getAttribute("class").indexOf("button-dict-speaker") >= 0) {
                        inputElement.src = getURLForDrawableResource("sound_loader.gif");
                        inputElement.setAttribute("type","image");
                        break;
                    }
                }
           }

          function onSoundLoadingExt(lang){
               var eles = document.getElementsByTagName("input");

               for (var i=0; i<eles.length; i++) {
                   var inputElement = eles[i];

                   if (inputElement.getAttribute("class").indexOf("b-sspk-ex") >= 0 || inputElement.getAttribute("class").indexOf("b-sspk") >= 0) {
                        if (inputElement.parentElement.getAttribute("lang")==lang){
                            inputElement.src = getURLForDrawableResource("sound_loader.gif");
                            inputElement.setAttribute("type","image");
                            break;
                       }
                   }
               }
          }


          function onSoundLoaded(dictID){
               var meaning = document.getElementById('meaning-' + dictID);
               var eles = meaning.getElementsByTagName("input");

               for (var i=0; i<eles.length; i++) {
                   var inputElement = eles[i];
                   if (inputElement.getAttribute("class").indexOf("button-dict-speaker") >= 0) {
                       inputElement.src = getURLForDrawableResource("ic_action_speaker_blue_big.png");
                       inputElement.setAttribute("type","image");
                       break;
                   }
               }
          }

        function onSoundLoadedExt(lang){
             var eles = document.getElementsByTagName("input");

             for (var i=0; i<eles.length; i++) {
                 var inputElement = eles[i];

                 if (inputElement.getAttribute("class").indexOf("b-sspk-ex") >= 0 || inputElement.getAttribute("class").indexOf("b-sspk") >= 0) {
                     if (inputElement.parentElement.getAttribute("lang")==lang){
                        inputElement.src = getURLForDrawableResource("ic_action_speaker_blue_big.png");
                        inputElement.setAttribute("type","image");
                        break;
                     }
                 }
             }
        }


            function elementsWithXPath(xpath) {
			    var arr = new Array();
			    try {
			        var iterator = document.evaluate(xpath, document, null, XPathResult.ANY_TYPE, null );
			        if (iterator) {

			            ele = iterator.iterateNext();
			            while (ele) {arr.push(ele); ele = iterator.iterateNext();}
			            return arr;
			        }
			    }catch(err) {
			    }

			    return arr;
			}

			function switchToTapMode(divID) {

			//alert(divID);


                //alert("ttt: " + window.devicePixelRatio);
               // alert(window.location);
               var query = "//div[@class='meaning']//text()";
               if (divID != null) {
			        query = "//div[@id='" + divID + "']//text()";
    			}

                arr = elementsWithXPath(query);
                for (var i=0; i<arr.length; i++) {
                    //alert(arr[i].textContent);

                    var parentNode = arr[i].parentNode;

                    if (parentNode.nodeName == "a" || parentNode.nodeName == "A" ||
                        parentNode.getAttribute("onclick") != null || arr[i].textContent == " ") {
                        arr[i].prelink = true;
						continue;
					}

                    try {

                        //if (arr[i].textContent == " ")
                            //alert("" + arr[i].toString());

                        var words = arr[i].textContent.split(" ");
                        for (var j=0; j<words.length; j++) {
                            var word = words[j].trim();
                            //alert(word);
                            if (word.length > 0) {
                                var a = document.createElement("span");
                                a.innerHTML = word + " ";
                                a.setAttribute('onclick','wlinkClicked(this)');
                                parentNode.insertBefore(a, arr[i]);
                            }
                        }
                    }
                    catch (err) {
                        //alert('ttt');
                    }


                }

                for (var i =0; i<arr.length; i++ ) {

                    if (arr[i].prelink) {
						continue;
					}

                    arr[i].parentNode.removeChild(arr[i]);
                }

            }

			function removeImgs() {

				var imgs = document.getElementsByTagName("IMG");
				//alert("" + imgs.length);
				for (var i=0; i< imgs.length; i++) {
					imgs[i].parentNode.removeChild(imgs[i]);
				}

				//alert("done");
			}

			function updatePicDictWithURL(url) {
                document.getElementById("img-dict").src = url;
            }

            function updateDictWithMeaning(elementID, content) {
                document.getElementById(elementID).innerHTML = content;
            }

            function hideDictMeaning(elementID){
                document.getElementById(elementID).style.display='none';
            }

            function showDictMeaning(elementID){
                document.getElementById(elementID).style.display='block';
            }

            function showOnlineDict(elementID,content,dictID,meaningID){
                document.getElementById(dictID).style.display='block';
                document.getElementById(elementID).innerHTML = content;

                //show speaker for online translator
                if (dictID!=null && dictID=='online_translator'){
                    var eles = document.getElementsByTagName("input");
                    for (var i=0; i<eles.length; i++) {
                        var inputElement = eles[i];

                        if (inputElement.getAttribute("class") == "b-sspk") {
                            inputElement.src = getURLForDrawableResource("ic_action_speaker_blue_big.png");
                            inputElement.setAttribute("type","image");
                            inputElement.setAttribute("onclick","onSpeakerTranslatorClicked(this);");
                        }
                    }
                }
                switchToTapMode(meaningID);
            }

            function hideFlashCardIndicator(elementID){
                document.getElementById(elementID).style.display='none';
            }

            function showFlashCardIndicator(elementID){
                document.getElementById(elementID).style.display='initial';
            }

            function jumpToSelectDict(dictID){
                document.getElementById(dictID).scrollIntoView(true);
            }



            function GT_onSourceLangChanged(event) {
    			sendMethod("webview_GTSourceChanged", event.target.value.toString());
			}

			function GT_onTargetLangChanged(event) {
    			sendMethod("webview_GTTargetChanged", event.target.value.toString());
			}


			function registerGTEvents() {

				//alert("done");

			    //var arrs = elementsWithXPath("//select[@class='ls-select sl']");
			    //arrs[0].addEventListener('change', GT_onSourceLangChanged, false);

			    //arrs = elementsWithXPath("//select[@class='ls-select tl']");
			    //arrs[0].addEventListener('change', GT_onTargetLangChanged, false);

			}

			function scrollToTopPage(){
			    window.scrollTo(0,0);
			}

//		    window.onscroll = function(ev) {
//                if ((window.innerHeight + window.scrollY) >= document.body.scrollHeight) {
//                  // you're at the bottom of the page
//                  //console.log("Bottom of page");
//                  sendMethod("scrollToEndPage","");
//                }
//            };
